#import "theController.h"
#import "CFGSocket.h"

@implementation theController

-(void)awakeFromNib{

[gwB0 setIntValue:0];
[gwB1 setIntValue:0];
[gwB2 setIntValue:0];
[gwB3 setIntValue:0];

[ipB0 setIntValue:192];
[ipB1 setIntValue:168];
[ipB2 setIntValue:33];
[ipB3 setIntValue:207];

[nmB0 setIntValue:255];
[nmB1 setIntValue:255];
[nmB2 setIntValue:255];
[nmB3 setIntValue:0];

[macAddr setStringValue:@"00:00:00:00:00:00:00:00"];

[btnClear setEnabled:YES];
[btnSet setEnabled:NO];
}


- (IBAction)clearIP:(id)sender
{
 NSString *theIPAddress=[NSString stringWithFormat:@"%d.%d.%d.%d",[ipB0 intValue],[ipB1 intValue],[ipB2 intValue],[ipB3 intValue]];
 CFGSocket *aFGSocketSetIP; 
 aFGSocketSetIP=[[CFGSocket alloc] init];
 [aFGSocketSetIP CreateSocketDGRAM:theIPAddress withPort:1024];
 [aFGSocketSetIP clearIP];
 [aFGSocketSetIP CloseConnection];
  [btnSet setEnabled:YES]; 
}

- (IBAction)setNewIP:(id)sender
{
 [self createAuthorization];
 [self repairToolOwn];

 CFGSocket *aFGSocketSetIP; 
 aFGSocketSetIP=[[CFGSocket alloc] init];
 [aFGSocketSetIP 
   bootPwithIPB0:[ipB0 intValue] ipB1:[ipB1 intValue] ipB2:[ipB2 intValue] ipB3:[ipB3 intValue]
       withGWB0:[gwB0 intValue] gwB1:[gwB1 intValue] gwB2:[gwB2 intValue] gwB3:[gwB3 intValue]
       withNMB0:[nmB0 intValue] nmB1:[nmB1 intValue] nmB2:[nmB2 intValue] nmb3:[nmB3 intValue]
	   macAddressInfo:macAddr
 ];
 [aFGSocketSetIP CloseConnection];
 [self deleteAuthorization];
 [btnSet setEnabled:NO]; 
}

-(void)createAuthorization{ 
 // Create an empty authorization
 OSStatus status;

 status = AuthorizationCreate(NULL, kAuthorizationEmptyEnvironment, kAuthorizationFlagDefaults, &authorizationRefROOT);
 if (status != errAuthorizationSuccess) {
  NSLog(@"startProcess: Failed to create the authref: %ld.\n", status);
 }

 //Preautorizzo user 
 if (![self preauthorizeForRight:PERMISSION_RIGHT]) {
  NSLog(@"Unable to preauthorize FGHelloDeviceAdv");
  return;
 }else
  NSLog(@"Authorized FGHelloDeviceAdv");
 
 
}
 
- (BOOL)preauthorizeForRight:(const char *)rightName
{
	OSStatus status;
	AuthorizationItem right = { rightName, 0, NULL, 0 };
	AuthorizationRights rightSet = { 1, &right };
	AuthorizationFlags flags = kAuthorizationFlagDefaults | kAuthorizationFlagPreAuthorize | kAuthorizationFlagInteractionAllowed | kAuthorizationFlagExtendRights | kAuthorizationFlagPartialRights;

	status = AuthorizationCopyRights(authorizationRefROOT, &rightSet, kAuthorizationEmptyEnvironment, flags, NULL);

	return (status == errAuthorizationSuccess);
}
 
 
 // Free the object authorization
 -(void)deleteAuthorization{
  AuthorizationFree(authorizationRefROOT, kAuthorizationFlagDestroyRights);
 }
  
  
 //Ripristino Owner Root e SUID bit  Own
-(void) repairToolOwn{
	NSString *strComandoSetOwner;
	NSString *strComandoSetUID;
	NSString *executablePath;
    AuthorizationRef authorizationRefROOTTmp;
    OSStatus status;
	status = AuthorizationCreate(NULL, kAuthorizationEmptyEnvironment, kAuthorizationFlagDefaults, &authorizationRefROOTTmp);
	if (status != errAuthorizationSuccess) {
		NSLog(@"repairToolOwn: Failed to create the authref: %ld.\n", status);
	}

	executablePath = [[NSBundle mainBundle] executablePath];

	NSDictionary *attributes = [[NSFileManager defaultManager] fileAttributesAtPath:executablePath traverseLink:YES];
	long int permission =[[attributes objectForKey:NSFilePosixPermissions] longValue];
    BOOL isCurrentSetUID = (permission & 0x800)==0x800;
    if(isCurrentSetUID==YES)
     return;
 
	strComandoSetOwner=[NSString stringWithString:@"/usr/sbin/chown"];	
	strComandoSetUID=[NSString stringWithString:@"/bin/chmod"];
	

	NSMutableArray *aNewArray;
	aNewArray=[[NSMutableArray alloc] init];
	
	[aNewArray addObject:@"4775"]; //SetUID
	[aNewArray addObject:executablePath];
  
	[self runCommandWithAutorization:strComandoSetUID  withArguments:aNewArray withAuthorizationRef:&authorizationRefROOTTmp];
	
	[aNewArray removeAllObjects];
	
	[aNewArray addObject:@"root"];
	[aNewArray addObject:executablePath];

	[self runCommandWithAutorization:strComandoSetOwner  withArguments:aNewArray withAuthorizationRef:&authorizationRefROOTTmp];
	
	[aNewArray removeAllObjects];

    [aNewArray release];

    AuthorizationFree(authorizationRefROOTTmp, kAuthorizationFlagDestroyRights);
	
	NSRunAlertPanel(@"Auto corrected permission.",@"The application now will be close, please launch it again.",@"Close",nil,nil);
	[NSApp terminate:self];
}
 
 
//Eseguo un comando in modalit  con un maggior privilegio di sicurezza
- (void) runCommandWithAutorization:(NSString*)command  withArguments:(NSArray *)argvs withAuthorizationRef:(AuthorizationRef*)theAuthorizationRef
{
    char* args[4096];
	int nElement=0;
	int nIndex=0;
	char myReadBuffer[1024];
    FILE* communicationsPipe=nil;
	OSStatus err = 0;
   	
	memset(myReadBuffer,0x00,1023);
	
	nElement=[argvs count];
  
	for(nIndex=0; nIndex<nElement;nIndex++){
	 args[nIndex]=(char*)[[argvs objectAtIndex:nIndex] cString];
	}
	args[nIndex]=NULL;
	
	
	NSLog(@"AuthorizationExecuteWithPrivileges - Eseguo: %@",command);
	
    err = AuthorizationExecuteWithPrivileges(*theAuthorizationRef,
											 [command cString],
											 0,
											 args,
											 &communicationsPipe);  
	

   if(err){
        NSLog(@"AuthorizationExecuteWithPrivileges - Errore %d durante l'esecuzione %@",err,command);
        NSBeep();
		return;
	 }
	
	for(;;){
		int bytesRead = read (fileno (communicationsPipe),myReadBuffer, sizeof (myReadBuffer));
		if (bytesRead < 1) 
		 break;
	 }
	
	fclose(communicationsPipe);
}

@end
